; 

    .686                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .data?


    .data

    .code _TEXT

option prologue:none
option epilogue:none

align 16
Axhex2dw    proc STDCALL lpszStr:DWORD

    push edi
    mov edi,[esp+8]
    mov eax,0

    @@:
    movzx edx,byte ptr [edi]
    ;movzx ecx,byte ptr [edi]
    mov ecx,edx
    cmp edx,0
    jz @done
    shr ecx,6
    and ecx,1
    add edi,1
    add edx,ecx
    shl eax,4h
    lea edx,[edx-30h+ecx*8]
    and edx,0fh
    add eax,edx
    jmp @B
   
    @done:
    ;pop ebp
    pop edi
    ret 4
Axhex2dw    endp

align 16
;db 0, 0, 0
l_htodw   proc lpString:dword
    pop      eax
	pop      edx
    movzx ecx, byte ptr [edx]
	push    eax
    xor       eax, eax
	push    ebx
	test      ecx, ecx
    je         @f    +1Ah
@@:
	shl       eax,  4
	add      ecx, -40h
    lea         ebx, [ecx+7]
	cmovb ebx, ecx
    add      edx, 1
	movzx ecx, byte ptr [edx]
	lea       eax, [eax+ebx+9]
    test     ecx, ecx
    jnz       @b
    pop     ebx
    ret 
l_htodw  endp
option prologue:PrologueDef
option epilogue:EpilogueDef
; 
; End of Copying


; 
; The testing prog
    .data

align 16
str1    db  "ABCDEF01",0

.code _TEXT
align 16
start proc uses ebx

invoke GetCurrentProcess
invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
invoke Sleep,0

; simple pre-output converted values, to show, what proc work...
add esp,-1024
invoke Axhex2dw,offset str1
mov ecx,esp
push eax
call @F
db	"%08lX",0
@@:
push ecx
call wsprintf

lea edx,[esp+12]
push MB_ICONINFORMATION
call @F
db	"Converted value",0
@@:
push edx
push 0
call MessageBox

invoke Sleep,1000

; Simple algo to get timings of Axhex2dw proc (not clocks cycles - milliseconds)
mov ebx,10000000
invoke GetTickCount
neg eax
push eax
@@:
REPEAT 10
invoke Axhex2dw,offset str1
ENDM
dec ebx
jnz @B
invoke GetTickCount
lea edx,[esp+4]
add [esp],eax
call @F
    db  "Axhex2dw Time %d ms",0
@@:
push edx
call wsprintf

lea ecx,[esp+12]    ; because we don't restore stack after wsprintf
push MB_ICONINFORMATION
call @F
db  "Timings",0
@@:
push ecx
push 0
call MessageBox

;invoke ExitProcess,0
invoke Sleep,1000


; Simple algo to get timings of l_htodw proc (not clocks cycles - milliseconds)
mov ebx,10000000
invoke GetTickCount
neg eax
push eax
@@:
REPEAT 10
invoke l_htodw,offset str1
ENDM
dec ebx
jnz @B
invoke GetTickCount
lea edx,[esp+4]
add [esp],eax
call @F
    db  "l_htodw Time %d ms",0
@@:
push edx
call wsprintf

lea ecx,[esp+12]    ; because we don't restore stack after wsprintf
push MB_ICONINFORMATION
call @F
db  "Timings",0
@@:
push ecx
push 0
call MessageBox


; quit, and esp restoration (12 - size of args to one wsprintf, wsprintf called 3 times, so...
; I don't restore stack after each call to wsprintf, because in such short code no need in it -
; is possibly restore stack once => reducing code size and execution time :)
add esp,1024+12+12+12

@done:
 ret
 
start endp

end start
